/*
 * (c) Marc Welz 2005, 2006, 2007:
 *
 * Only to be distributed under the conditions of the GNU GPL v3 or newer
 * as published by the Free Software Foundation, with all anti-DRM and
 * anti-patent measures enabled
 */

#include <stdlib.h>
#include <stdio.h>

#include "mxk.h"

int mxk_send_client(struct list_loop *ls, struct task_loop *tl, struct mxk_client *vector, int count, int type, int code, int value)
{
  struct task_loop *tx;
  struct mxk_client *c;
  int i, result;

  result = 0;
  for(i = 0; i < count; i++){
    c = &(vector[i]);
    for(tx = find_task_tag_loop(ls, NULL, NULL, c->c_type, c->c_id); tx; tx = find_task_tag_loop(ls, NULL, tx, c->c_type, c->c_id)){
#ifdef DEBUG
      fprintf(stderr, "client: sending (%d,0x%02x,%d) to [%d]%p: ([%d]%s:%d)->(%d,%d)\n", type, code, value, i, tx, type_loop(ls, tl), type_name_loop(ls, tl), tag_loop(ls, tl), c->c_type, c->c_id);
#endif
      if(mxk_send_switch(ls, tl, tx, type, code, value) == 0){
        if(result >= 0){
          result++;
        }
      } else {
#ifdef DEBUG
        fprintf(stderr, "client: unable to send to client\n");
#endif
        result = (-1);
      }
    }
  }

  return result;
}

struct mxk_client *mxk_insert_client(struct mxk_client *vector, int count, int type, int id)
{
  struct mxk_client *v;

#ifdef DEBUG
  fprintf(stderr, "insert: target[%d]=%d:%d\n", count, type, id);
#endif

  v = realloc(vector, sizeof(struct mxk_client) * (count + 1));
  if(v == NULL){
    return NULL;
  }

  v[count].c_type = type;
  v[count].c_id = id;

  return v;
}

void mxk_shutdown_client(struct mxk_client *vector, int count)
{
  if(vector){
    free(vector);
  }
}
