/*
 * (c) Marc Welz 2006:
 *
 * Only to be distributed under the conditions of the GNU GPL v2 or newer
 * as published by the Free Software Foundation, with all anti-DRM and
 * anti-patent measures enabled
 */

#include <string.h>

#include "code-name.h"

int name_to_code(struct code_name *cn, char *name)
{
  int i;

  if(name == NULL){
    for(i = 0; cn[i].name; i++);
  } else {
    for(i = 0; cn[i].name && strcmp(cn[i].name, name); i++);
  }

  return cn[i].code;
}

char *code_to_name(struct code_name *cn, int code)
{
  int i;

  for(i = 0; cn[i].name && (cn[i].code != code); i++);

  return cn[i].name;
}

#ifdef STANDALONE

struct code_name table[] = {
  { "foo", 42  }, 
  { "bar", 21  }, 
  { NULL, -1 }
};

#define BUFFER 64
#include <stdio.h>

int main()
{
  char buffer[BUFFER];
  char *ptr;
  int code;

  while(fgets(buffer, BUFFER - 1, stdin)){
    ptr = strchr(buffer, '\n');
    if(ptr) ptr[0] = '\0';
    ptr = strchr(buffer, '\r');
    if(ptr) ptr[0] = '\0';

    code = name_to_code(table, buffer);
    ptr = code_to_name(table, code);

    printf("%s:%d\n", ptr, code);
  }

  return 0;
}
#endif
