/*
 * (c) Marc Welz 2005, 2006, 2007:
 *
 * Only to be distributed under the conditions of the GNU GPL v3 or newer
 * as published by the Free Software Foundation, with all anti-DRM and
 * anti-patent measures enabled
 */

#include <stdio.h>

#include <loop.h>
#include <word-work.h>

#include "mxk.h"

int mxk_list_codes_command(struct list_loop *ls, struct task_loop *tl, char *args)
{
  struct control_loop *cl;
  int cd, i;

  cl = user_loop(ls, tl);
  cd = fd_loop(ls, tl);

  for(i = 0; mxk_key_codes[i].code < KEY_MAX; i++){
    print_control(cl, cd, 0, "0x%03x %3d: %s\n", mxk_key_codes[i].code, mxk_key_codes[i].code, mxk_key_codes[i].name);
  }

  print_control(cl, cd, 1, "%d entries (virtual keys omitted)\n", i);

  return 0;
}

int mxk_list_relative_command(struct list_loop *ls, struct task_loop *tl, char *args)
{
  struct control_loop *cl;
  int cd, i;

  cl = user_loop(ls, tl);
  cd = fd_loop(ls, tl);

  for(i = 0; mxk_rel_codes[i].name; i++){
    print_control(cl, cd, 0, "0x%03x %3d: %s\n", mxk_rel_codes[i].code, mxk_rel_codes[i].code, mxk_rel_codes[i].name);
  }

  print_control(cl, cd, 1, "%d entries\n", i);

  return 0;
}

int mxk_list_absolute_command(struct list_loop *ls, struct task_loop *tl, char *args)
{
  struct control_loop *cl;
  int cd, i;

  cl = user_loop(ls, tl);
  cd = fd_loop(ls, tl);

  for(i = 0; mxk_abs_codes[i].name; i++){
    print_control(cl, cd, 0, "0x%03x %3d: %s\n", mxk_abs_codes[i].code, mxk_abs_codes[i].code, mxk_abs_codes[i].name);
  }

  print_control(cl, cd, 1, "%d entries\n", i);

  return 0;
}

int mxk_list_events_command(struct list_loop *ls, struct task_loop *tl, char *args)
{
  struct control_loop *cl;
  int cd, i;

  cl = user_loop(ls, tl);
  cd = fd_loop(ls, tl);

  for(i = 0; mxk_event_types[i].name != NULL; i++){
    print_control(cl, cd, 0, "0x%03x %3d: %s\n", mxk_event_types[i].code, mxk_event_types[i].code, mxk_event_types[i].name);
  }

  print_control(cl, cd, 1, "%d event types\n", i);

  return 0;
}
