/*
 * (c) Marc Welz 1999, 2004, 2005, 2006:
 *
 * Only to be distributed under the conditions of the GNU GPL v2 or newer
 * as published by the Free Software Foundation, with all anti-DRM and
 * anti-patent measures enabled
 */

#include <stdio.h>
#include <sys/time.h>
#include <sys/types.h>

#include "priv.h"

int cmp_time_loop(struct timeval *alpha, struct timeval *beta)
{
  if(alpha->tv_sec < beta->tv_sec){
    return -1;
  }

  if(alpha->tv_sec > beta->tv_sec){
    return 1;
  }

  if(alpha->tv_usec < beta->tv_usec){
    return -1;
  }

  if(alpha->tv_usec > beta->tv_usec){
    return 1;
  }

  return 0;
}

int add_time_loop(struct timeval *sigma, struct timeval *alpha, struct timeval *beta)
{
  if(alpha->tv_usec + beta->tv_usec >= 1000000){
    sigma->tv_sec = alpha->tv_sec + beta->tv_sec + 1;
    sigma->tv_usec = (alpha->tv_usec + beta->tv_usec) - 1000000;
  } else {
    sigma->tv_sec = alpha->tv_sec + beta->tv_sec;
    sigma->tv_usec = alpha->tv_usec + beta->tv_usec;
  }
#ifdef DEBUG
  fprintf(stderr, "time: %ld.%06ld + %ld.%06ld = %ld.%06ld\n", alpha->tv_sec, alpha->tv_usec, beta->tv_sec, beta->tv_usec, sigma->tv_sec, sigma->tv_usec);
#endif
  return 0;
}

int sub_time_loop(struct timeval *delta, struct timeval *alpha, struct timeval *beta)
{
#ifdef DEBUG
  fprintf(stderr, "time: %ld.%06ld - %ld.%06ld\n", alpha->tv_sec, alpha->tv_usec, beta->tv_sec, beta->tv_usec);
#endif
  if(alpha->tv_usec < beta->tv_usec){
    if(alpha->tv_sec <= beta->tv_sec){
      delta->tv_sec  = 0;
      delta->tv_usec = 0;
      return -1;
    } else {
      delta->tv_sec  = alpha->tv_sec - (beta->tv_sec + 1);
      delta->tv_usec = (1000000 + alpha->tv_usec) - beta->tv_usec;
      return 0;
    }
  } else {
    if(alpha->tv_sec < beta->tv_sec){
      delta->tv_sec  = 0;
      delta->tv_usec = 0;
      return -1;
    } else {
      delta->tv_sec  = alpha->tv_sec  - beta->tv_sec;
      delta->tv_usec = alpha->tv_usec - beta->tv_usec;
      return 0;
    }
  }
}

