/*
 * (c) Marc Welz 2005, 2006, 2007:
 *
 * Only to be distributed under the conditions of the GNU GPL v3 or newer
 * as published by the Free Software Foundation, with all anti-DRM and
 * anti-patent measures enabled
 */

#include <linux/input.h>
#include <linux/kdev_t.h>

#include <loop.h>

#include "mxk.h"

int mxk_send_switch(struct list_loop *ls, struct task_loop *tl, struct task_loop *tx, int type, int code, int value)
{
  /* TODO: add an option to append a sync */

  struct mxk_global *mg;
  struct link_loop *nk;
  struct input_event *vt;

  mg = global_loop(ls);

  nk = send_link_loop(ls, tl, tx, mg->g_event);
  if(nk == NULL){
    return -1;
  }

  vt = alloc_link_loop(ls, nk, mg->g_event, sizeof(struct input_event));
  if(vt == NULL){
    discard_link_loop(ls, nk);
    return -1;
  }

#if 0
  gettimeofday(&(vt->time), NULL);
#endif
  vt->type = type;
  vt->code = code;
  vt->value = value;

  return 0;
}
